//Project: 
//Date: Oct 31, 2006
//Author: andi
//File name: ConnectionData.java

package org.itbikers.idea.ssh.client;


/**
 * Bean storing all the connection data.
 *
 * @author Andrei Diaconu-Muresan
 */
public class ConnectionData {

	/**
	 * If default value if port is left <em>null</em>.
	 */
	private static final int DEFAULT_PORT = 22;

	private String sessionName;
	private String hostname;
	private Integer port;
	private String username;
	private String password;
	private String command;

	/**
	 * Default constructor.
	 */
	public ConnectionData() {
		this.sessionName = "";
	}

	public String getHostname() {
		return hostname;
	}

	public void setHostname(String hostname) {
		this.hostname = hostname;
	}

	public Integer getPort() {
		return port != null ? port : DEFAULT_PORT;
	}

	public void setPort(Integer port) {
		this.port = port;
	}

	public String getUsername() {
		return username;
	}

	public void setUsername(String username) {
		this.username = username;
	}

	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password;
	}

	public String getCommand() {
		return command != null ? command : "";
	}

	public void setCommand(String command) {
		if (command == null)
			this.command = "";
		else
			this.command = command;
		if (this.command.length() > 0 && !this.command.endsWith("\n"))
			this.command = this.command + "\n";
	}


	/**
	 * Returns the session name. For run configurations, this is the name of the configuration.
	 * If the SSH is started from an action, this is name@host
	 *
	 * @return the name of the session.
	 */
	public String getSessionName() {
		if (sessionName != null && !sessionName.equals(""))
			return sessionName;
		else
			return username + '@' + hostname;
	}

	public void setSessionName(String sessionName) {
		this.sessionName = sessionName;
	}
}
