package org.itbikers.idea.ssh.resources.images;

import javax.swing.*;
import java.util.HashMap;
import java.util.Map;

/**
 * Idea SSH icon loader.
 *
 * @author mihai.slavcovici
 */
public class IconLoader {

	private static final Map<String, Icon> icons = new HashMap<String, Icon>();

	private IconLoader() {
	}

	public static Icon get(String path) {
		Icon icon = icons.get(path);
		if (icon == null) {
			icon = com.intellij.openapi.util.IconLoader.getIcon(path);
			icons.put(path, icon);
		}
		return icon;
	}
}
