package org.itbikers.idea.ssh.resources.messages;

import com.intellij.CommonBundle;
import org.jetbrains.annotations.PropertyKey;

import java.lang.ref.Reference;
import java.lang.ref.SoftReference;
import java.util.ResourceBundle;

/**
 * Idea SSH plugin resource bundle.
 *
 * @author mihai.slavcovici
 */
public class SSHBundle {

	private static Reference<ResourceBundle> ourBundle;

	private static final String SSH_BUNDLE_PATH = "org.itbikers.idea.ssh.resources.messages.SSHBundle";

	private SSHBundle() {
	}

	public static String message(@PropertyKey(resourceBundle = "org.itbikers.idea.ssh.resources.messages.SSHBundle")String key,
	                             Object... params) {
		return CommonBundle.message(getBundle(), key, params);
	}

	private static ResourceBundle getBundle() {
		ResourceBundle bundle = null;
		if (ourBundle != null) {
			bundle = ourBundle.get();
		}
		if (bundle == null) {
			bundle = ResourceBundle.getBundle(SSH_BUNDLE_PATH);
			ourBundle = new SoftReference<ResourceBundle>(bundle);
		}
		return bundle;
	}
}
