package org.itbikers.idea.ssh.ui;

import com.intellij.ui.DocumentAdapter;

import javax.swing.*;
import javax.swing.event.DocumentEvent;
import java.awt.event.*;

public class PasswordDialog extends JDialog {
	private JPanel contentPane;
	private JButton buttonOK;
	private JButton buttonCancel;
	private JPasswordField passwordField;
	private boolean ok;

	public PasswordDialog() {
		setContentPane(contentPane);
		setModal(true);
		getRootPane().setDefaultButton(buttonOK);

		buttonOK.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				onOK();
			}
		});

		buttonCancel.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				onCancel();
			}
		});

// call onCancel() when cross is clicked
		setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				onCancel();
			}
		});

// call onCancel() on ESCAPE
		contentPane.registerKeyboardAction(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				onCancel();
			}
		}, KeyStroke.getKeyStroke(KeyEvent.VK_ESCAPE, 0), JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
		this.init();
	}

	private void init() {
		this.passwordField.getDocument().addDocumentListener(new DocumentAdapter() {
			protected void textChanged(DocumentEvent e) {
				final String password = new String(passwordField.getPassword());
				buttonOK.setEnabled(password.length() > 0);
			}
		});
	}

	private void onOK() {
		this.ok = true;
		dispose();
	}

	private void onCancel() {
		this.ok = false;
		dispose();
	}


	public boolean isOk() {
		return ok;
	}


	public String getPassword() {
		return new String(passwordField.getPassword());
	}
}
