package org.itbikers.idea.ssh.ui.rundebug;

import com.intellij.openapi.options.ConfigurationException;
import com.intellij.openapi.options.SettingsEditor;
import org.jetbrains.annotations.NotNull;

import javax.swing.*;

/**
 * UI form for SSH configurations.
 *
 * @author mihai.slavcovici
 */
public class SSHRunDebugConfigForm extends SettingsEditor<SSHRunConfiguration> {

	private static final String DEFAULT_SSH_PORT = "22";
	private JPanel mainPanel;
	private JTextField hostNameTextField;
	private JTextField portTextField;
	private JTextField userNameTextField;
	private JPasswordField passwordTextField;
	private JTextArea commandTextArea;

	public SSHRunDebugConfigForm() {
		init();
	}


	/**
	 * Set default values.
	 */
	private void init() {
		portTextField.setText(DEFAULT_SSH_PORT);
	}

	protected void resetEditorFrom(SSHRunConfiguration s) {
		hostNameTextField.setText(s.getHostname());
		portTextField.setText(s.getPort());
		userNameTextField.setText(s.getUsername());
		passwordTextField.setText(s.getPassword());
		commandTextArea.setText(s.getCommand());
	}

	protected void applyEditorTo(SSHRunConfiguration s)
			throws ConfigurationException {
		try {
			s.setHostname(hostNameTextField.getText());
			s.setPort(portTextField.getText());
			s.setUsername(userNameTextField.getText());
			s.setPassword(new String(passwordTextField.getPassword()));
			s.setCommand(commandTextArea.getText());
		} catch (Exception e) {
			e.printStackTrace();//todo
		}
	}


	@NotNull
	protected JComponent createEditor() {
		return mainPanel;
	}

	protected void disposeEditor() {
	}
}
