package org.itbikers.idea.ssh.ui.rundebug;

import com.intellij.execution.configurations.ConfigurationFactory;
import com.intellij.execution.configurations.ConfigurationType;
import com.intellij.openapi.application.ApplicationManager;
import org.itbikers.idea.ssh.resources.images.IconLoader;
import org.itbikers.idea.ssh.resources.messages.SSHBundle;
import org.jetbrains.annotations.NotNull;

import javax.swing.*;

/**
 * Application level component for SSH plugin.
 * Main menu - Run - Edit configurations - Add
 * Add in Edit configurations support for default values! todo
 *
 * @author mihai.slavcovici
 */
public class SSHRunDebugConfigType implements ConfigurationType {

	private SSHConfigurationFactory myConfigurationFactory;

	SSHRunDebugConfigType() {
		myConfigurationFactory = new SSHConfigurationFactory(this);
	}

	public void initComponent() {
	}

	public void disposeComponent() {
	}

	@NotNull
	public String getComponentName() {
		return "org.itbikers.idea.ssh.ui.rundebug.SSHRunDebugConfigType";
	}

	public String getDisplayName() {
		return SSHBundle.message("ssh.rundebug.config.title");
	}

	public String getConfigurationTypeDescription() {
		return SSHBundle.message("ssh.rundebug.config.description");
	}

	public Icon getIcon() {
		return IconLoader.get("ssh.png");
	}

	public ConfigurationFactory[] getConfigurationFactories() {
		return new ConfigurationFactory[]{myConfigurationFactory};
	}

	public static SSHConfigurationFactory getFactory() {
		return ApplicationManager.getApplication().getComponent(SSHRunDebugConfigType.class).myConfigurationFactory;
	}
}
